// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice
#include "system_modes_msgs/msg/detail/mode_event__rosidl_typesupport_fastrtps_cpp.hpp"
#include "system_modes_msgs/msg/detail/mode_event__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace system_modes_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const system_modes_msgs::msg::Mode &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  system_modes_msgs::msg::Mode &);
size_t get_serialized_size(
  const system_modes_msgs::msg::Mode &,
  size_t current_alignment);
size_t
max_serialized_size_Mode(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace system_modes_msgs

// functions for system_modes_msgs::msg::Mode already declared above


namespace system_modes_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_system_modes_msgs
cdr_serialize(
  const system_modes_msgs::msg::ModeEvent & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: timestamp
  cdr << ros_message.timestamp;
  // Member: start_mode
  system_modes_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.start_mode,
    cdr);
  // Member: goal_mode
  system_modes_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.goal_mode,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_system_modes_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  system_modes_msgs::msg::ModeEvent & ros_message)
{
  // Member: timestamp
  cdr >> ros_message.timestamp;

  // Member: start_mode
  system_modes_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.start_mode);

  // Member: goal_mode
  system_modes_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.goal_mode);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_system_modes_msgs
get_serialized_size(
  const system_modes_msgs::msg::ModeEvent & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: timestamp
  {
    size_t item_size = sizeof(ros_message.timestamp);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: start_mode

  current_alignment +=
    system_modes_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.start_mode, current_alignment);
  // Member: goal_mode

  current_alignment +=
    system_modes_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.goal_mode, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_system_modes_msgs
max_serialized_size_ModeEvent(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: timestamp
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: start_mode
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        system_modes_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Mode(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: goal_mode
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        system_modes_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Mode(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = system_modes_msgs::msg::ModeEvent;
    is_plain =
      (
      offsetof(DataType, goal_mode) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _ModeEvent__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const system_modes_msgs::msg::ModeEvent *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _ModeEvent__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<system_modes_msgs::msg::ModeEvent *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _ModeEvent__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const system_modes_msgs::msg::ModeEvent *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _ModeEvent__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_ModeEvent(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _ModeEvent__callbacks = {
  "system_modes_msgs::msg",
  "ModeEvent",
  _ModeEvent__cdr_serialize,
  _ModeEvent__cdr_deserialize,
  _ModeEvent__get_serialized_size,
  _ModeEvent__max_serialized_size
};

static rosidl_message_type_support_t _ModeEvent__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_ModeEvent__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace system_modes_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_system_modes_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<system_modes_msgs::msg::ModeEvent>()
{
  return &system_modes_msgs::msg::typesupport_fastrtps_cpp::_ModeEvent__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, system_modes_msgs, msg, ModeEvent)() {
  return &system_modes_msgs::msg::typesupport_fastrtps_cpp::_ModeEvent__handle;
}

#ifdef __cplusplus
}
#endif
